/*
 * This file was automaticly generated by clo++ version 0.6.4 (REL-0_6_4)
 * http://pmade.org/pjones/software/clo++/
 *
 * Template enhancements by Stefan Hoops mailto:shoops@vt.edu
 */

/**
 * This file contains the implementation of the parser class.
 * You can control the name of this source file using the
 * cxx_source_file variable.
 */

#ifdef WIN32
#pragma warning (disable: 4786)
#define strcasecmp _stricmp
#endif

#include "clo.h"
#include <cstring>
#include <cstdlib>
#include <cctype>
#include <fstream>
#include <sstream>
#include <errno.h>

namespace {
    const char const_usage[] =
"  --biplot-alpha double             alpha value for biplot scaling (0 for\n"
"                                    samples, 1 for variables)\n"
"  --biplot-dim int                  create 2D or 3D biplot of rows and\n"
"                                    columns (applies to PCA)\n"
"  --biplot-vars string              file with selected variables to include\n"
"                                    in biplot (note: all variables are used\n"
"                                    to define PCA rotation)\n"
"  --comparative-correlation double  p-value for correlation testing\n"
"  --corr-threshold double           correlation threshold\n"
"  --ga-generations int              number of generations for GA algorithm\n"
"  --ga-genes int                    number of genes for GA algorithm\n"
"                                    (0=auto)\n"
"  --ga-population int               population size for GA algorithm\n"
"  --log-plots                       logarithmic scatter plots\n"
"  --logdata base                    log transform data, (base 2, 10 or e)\n"
"  --normalize-plots                 normalize scatter plots\n"
"  --plot-png                        gnuplot output in PNG format\n"
"  --proj-2dplots                    create 2D data projection plots\n"
"  --proj-dimension int              dimension to project data\n"
"  --proj-variance double            minimum variance kept in projection\n"
"  --pval double                     p-value threshold\n"
"  --samples-center                  center variables to mean zero\n"
"  --samples-total double            scale samples to given total\n"
"  --samples-z                       standardize samples to mean zero,\n"
"                                    variance one\n"
"  --scale-plots                     scale scatter plots\n"
"  --scatterplots                    create scatter plots\n"
"  --spearman                        calculate Spearman rank correlations\n"
"  --vars-center                     center variables to mean zero\n"
"  --vars-z                          standardize variables to mean zero,\n"
"                                    variance one\n"
"  --version                         output version information and exit\n"
"  -f, --format int                  input file format: attr. row=1 columns=2\n"
"  -g, --corr-graph                  represent correlations as a graph\n"
"  -m, --method method name          analysis method, one of: correlation,\n"
"                                    partial_correlation, pca, fa, nmf, mda,\n"
"                                    ga-dfa, ga-dfa2, transpose\n"
"  -o, --output string               name for output files\n"
"  -v, --verbose int                 print detailed information\n";

    const char const_help_comment[] =
"use the -h option for help";

    const char* expand_long_name (const std::string &name);
}

//#########################################################################
clo::parser::parser (void)
    : state_(state_option)
{
    memset(&locations_, 0, sizeof(locations_));
}
//#########################################################################
void clo::parser::parse(int argc, char *argv[], bool call_finalize) {
    int i=1;

#ifdef Darwin
  if (argc > 1)
    {
      std::string tmp(argv[1]);
      if (!tmp.compare(0, 4, "-psn")) i = 2;
    }
#endif // Darwin

    for (; i<argc; ++i) parse_element(argv[i], i, source_cl);

    if (call_finalize) finalize();
}
//#########################################################################
void clo::parser::parse(const char * fileName)
{
  int LineCounter = 0;
  std::string Line;
  std::string Option;
  std::string Value;
  std::string::size_type pos;
  std::ifstream File(fileName);

  if (File.fail())
    {
      std::ostringstream error;
      error << "error opening file: '" << fileName << "'";
      errno = ENOENT;

      throw option_error(error.str());
    }

  while (true)
    {
      try
        {
          std::getline(File, Line);
          LineCounter++;

          if (File.eof()) break;
          if (File.fail())
            {
              std::ostringstream error;
              error << "unknown problem";

              throw option_error(error.str());
            }

#ifndef WIN32
          /* Take care of dos style line ending under UNIX */
          /* A case where MS has the better implementation */
          pos = Line.length();
          (pos < 1) ? 0 : pos--;
          if (Line[pos] == 0xd) Line.erase(pos);
#endif  // not WIN32

          // eat leading spaces
          Line.erase(0, Line.find_first_not_of(' '));

          // skip comments and empty lines
          if (Line.length() == 0 || Line[0] == '#') continue;

          // find first position of '=' or ':'
          pos = Line.find_first_of(":=");

          Option = "--" + Line.substr(0, pos);
          Option.erase(Option.find_last_not_of(' ') + 1);

          parse_element(Option.c_str(), 0, source_cf);

          if (pos != std::string::npos) // We have a '='
            {
              Value = Line.substr(pos + 1);
              Value.erase(0, Value.find_first_not_of(' '));
              Value.erase(Value.find_last_not_of(' ') + 1);

              if (Value.length()) parse_element(Value.c_str(), 0, source_cf);
            }

          finalize();
        }

      catch (clo::option_error &e)
        {
          std::ostringstream error;
          error << "error reading file: '" << fileName << "(" << LineCounter
          << ")': " << e.what();

          throw option_error(error.str());
        }
    }

  File.clear();
  File.close();
}
//#########################################################################
void clo::parser::finalize (void) {
    if (state_ == state_value) {
	switch (openum_) {
	    case option_biplot:
		throw option_error("missing value for 'biplot-dim' option");
	    case option_biplotalpha:
		throw option_error("missing value for 'biplot-alpha' option");
	    case option_biplotvars:
		throw option_error("missing value for 'biplot-vars' option");
	    case option_compcorr:
		throw option_error("missing value for 'comparative-correlation' option");
	    case option_corrgraph:
		throw option_error("missing value for 'corr-graph' option");
	    case option_corrthresh:
		throw option_error("missing value for 'corr-threshold' option");
	    case option_format:
		throw option_error("missing value for 'format' option");
	    case option_gagenerations:
		throw option_error("missing value for 'ga-generations' option");
	    case option_gagenes:
		throw option_error("missing value for 'ga-genes' option");
	    case option_gapop:
		throw option_error("missing value for 'ga-population' option");
	    case option_logdata:
		throw option_error("missing value for 'logdata' option");
	    case option_method:
		throw option_error("missing value for 'method' option");
	    case option_output:
		throw option_error("missing value for 'output' option");
	    case option_proj2dplots:
		throw option_error("missing value for 'proj-2dplots' option");
	    case option_projdim:
		throw option_error("missing value for 'proj-dimension' option");
	    case option_projvar:
		throw option_error("missing value for 'proj-variance' option");
	    case option_pval:
		throw option_error("missing value for 'pval' option");
	    case option_samplescenter:
		throw option_error("missing value for 'samples-center' option");
	    case option_samplesz:
		throw option_error("missing value for 'samples-z' option");
	    case option_sampletot:
		throw option_error("missing value for 'samples-total' option");
	    case option_spearman:
		throw option_error("missing value for 'spearman' option");
	    case option_splot:
		throw option_error("missing value for 'scatterplots' option");
	    case option_splotlog:
		throw option_error("missing value for 'log-plots' option");
	    case option_splotnormal:
		throw option_error("missing value for 'normalize-plots' option");
	    case option_splotpng:
		throw option_error("missing value for 'plot-png' option");
	    case option_splotscale:
		throw option_error("missing value for 'scale-plots' option");
	    case option_varscenter:
		throw option_error("missing value for 'vars-center' option");
	    case option_varsz:
		throw option_error("missing value for 'vars-z' option");
	    case option_verbose:
		throw option_error("missing value for 'verbose' option");
	    case option_version:
		throw option_error("missing value for 'version' option");
	}

    }

}
//#########################################################################
void clo::parser::parse_element (const char *element, int position, opsource source) {
    size_t length = strlen(element);

    switch (state_) {
	case state_consume:
	    non_options_.push_back(element);
	    break;
	case state_option:
	    if (length >= 2 && element[0] == '-' && element[1] == '-') {
		if (length == 2) { state_ = state_consume; return; }
		element += 2;
		const char *value = element;
		while (*value != 0 && *value != '=') ++value;
		if (*value == '=') {
		    std::string selement(element, value - element), svalue(++value);

		    parse_long_option(selement.c_str(), position, source);
		    if (state_ != state_value) {
			std::string error("the '"); error += element; error += "' option does not take a value";
			throw option_error(error);
		    }

		    parse_value(svalue.c_str());
		    state_ = state_option;
		} else {
		    parse_long_option(element, position, source);
		}
	    } else if (length >= 2 && element[0] == '-') {
		++element;

		if (length > 2) {
		    while (*element != 0) {
			parse_short_option(*element, position, source);
			++element;
	
			if (state_ == state_value && *element == '=') {
			    parse_value(++element);
			    state_ = state_option;
			    break;
			}
                   else if (state_ == state_value) finalize();
		    }
		} else {
		    parse_short_option(*element, position, source);
		}
	    } else {
		non_options_.push_back(element);
	    }
	    break;
	case state_value:
	    parse_value(element);
	    state_ = state_option;
	    break;
    }
}
//#########################################################################
void clo::parser::parse_short_option (char option, int position, opsource source) {
    switch (option) {
    	case 'f':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_format;
    	    state_ = state_value;
    	    locations_.format = position;
    	    return;
    	case 'g':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_corrgraph;
    	    options_.corrgraph = !options_.corrgraph;
    	    locations_.corrgraph = position;
    	    return;
    	case 'm':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_method;
    	    state_ = state_value;
    	    locations_.method = position;
    	    return;
    	case 'o':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_output;
    	    state_ = state_value;
    	    locations_.output = position;
    	    return;
    	case 'v':
    	    source = source; // kill compiler unused variable warning
    	    openum_ = option_verbose;
    	    state_ = state_value;
    	    locations_.verbose = position;
    	    return;
    	case 'h':
    	    if (source != source_cl) break;
    	    throw autoexcept(autothrow_help, const_usage);
    	case '?':
    	    if (source != source_cl) break;
    	    throw autoexcept(autothrow_help, const_usage);
    }

    std::string error("unknown option: '"); error += option; error += "'";
    throw option_error(error);
}
//#########################################################################
void clo::parser::parse_long_option (const char *option, int position, opsource source) {
    option = expand_long_name(option);

	    if (strcmp(option, "biplot-alpha") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_biplotalpha;
		locations_.biplotalpha = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "biplot-dim") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_biplot;
		locations_.biplot = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "biplot-vars") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_biplotvars;
		locations_.biplotvars = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "comparative-correlation") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_compcorr;
		locations_.compcorr = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "corr-graph") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_corrgraph;
		locations_.corrgraph = position;
		options_.corrgraph = !options_.corrgraph;
		return;
	    } else if (strcmp(option, "corr-threshold") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_corrthresh;
		locations_.corrthresh = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "format") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_format;
		locations_.format = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "ga-generations") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_gagenerations;
		locations_.gagenerations = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "ga-genes") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_gagenes;
		locations_.gagenes = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "ga-population") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_gapop;
		locations_.gapop = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "log-plots") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_splotlog;
		locations_.splotlog = position;
		options_.splotlog = !options_.splotlog;
		return;
	    } else if (strcmp(option, "logdata") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_logdata;
		locations_.logdata = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "method") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_method;
		locations_.method = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "normalize-plots") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_splotnormal;
		locations_.splotnormal = position;
		options_.splotnormal = !options_.splotnormal;
		return;
	    } else if (strcmp(option, "output") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_output;
		locations_.output = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "plot-png") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_splotpng;
		locations_.splotpng = position;
		options_.splotpng = !options_.splotpng;
		return;
	    } else if (strcmp(option, "proj-2dplots") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_proj2dplots;
		locations_.proj2dplots = position;
		options_.proj2dplots = !options_.proj2dplots;
		return;
	    } else if (strcmp(option, "proj-dimension") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_projdim;
		locations_.projdim = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "proj-variance") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_projvar;
		locations_.projvar = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "pval") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_pval;
		locations_.pval = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "samples-center") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_samplescenter;
		locations_.samplescenter = position;
		options_.samplescenter = !options_.samplescenter;
		return;
	    } else if (strcmp(option, "samples-total") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_sampletot;
		locations_.sampletot = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "samples-z") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_samplesz;
		locations_.samplesz = position;
		options_.samplesz = !options_.samplesz;
		return;
	    } else if (strcmp(option, "scale-plots") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_splotscale;
		locations_.splotscale = position;
		options_.splotscale = !options_.splotscale;
		return;
	    } else if (strcmp(option, "scatterplots") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_splot;
		locations_.splot = position;
		options_.splot = !options_.splot;
		return;
	    } else if (strcmp(option, "spearman") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_spearman;
		locations_.spearman = position;
		options_.spearman = !options_.spearman;
		return;
	    } else if (strcmp(option, "vars-center") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_varscenter;
		locations_.varscenter = position;
		options_.varscenter = !options_.varscenter;
		return;
	    } else if (strcmp(option, "vars-z") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_varsz;
		locations_.varsz = position;
		options_.varsz = !options_.varsz;
		return;
	    } else if (strcmp(option, "verbose") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_verbose;
		locations_.verbose = position;
		state_ = state_value;
		return;
	    } else if (strcmp(option, "version") == 0) {
		source = source; // kill compiler unused variable warning
		openum_ = option_version;
		locations_.version = position;
		options_.version = !options_.version;
		return;
	    } else if (source == source_cl && strcmp(option, "help") == 0) {
		throw autoexcept(autothrow_help, const_usage);
	    }

    std::string error("unknown option '"); error += option; error += "'";
    throw option_error(error);
}
//#########################################################################
void clo::parser::parse_value (const char *value) {
    switch (openum_) {
    	case option_biplot:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 0) {
    		    throw option_error("integer value out of range, 'biplot-dim' min is 0");
    		}

    		if (tmp > 3) {
    		    throw option_error("integer value out of range, 'biplot-dim' max is 3");
    		}

    		options_.biplot = tmp;
    	    }
    	    break;
    	case option_biplotalpha:
    	    {
    		char *endptr; double tmp = std::strtod(value, &endptr);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid floating point value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 0.0) {
    		    throw option_error("floating point value out of range, 'biplot-alpha' min is 0.0");
    		}

    		if (tmp > 1.0) {
    		    throw option_error("floating point value out of range, 'biplot-alpha' max is 1.0");
    		}

    		options_.biplotalpha = tmp;
    	    }
    	    break;
    	case option_biplotvars:
    	    {
    		options_.biplotvars = value;
    	    }
    	    break;
    	case option_compcorr:
    	    {
    		char *endptr; double tmp = std::strtod(value, &endptr);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid floating point value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 0.0) {
    		    throw option_error("floating point value out of range, 'comparative-correlation' min is 0.0");
    		}

    		if (tmp > 1.0) {
    		    throw option_error("floating point value out of range, 'comparative-correlation' max is 1.0");
    		}

    		options_.compcorr = tmp;
    	    }
    	    break;
    	case option_corrgraph:
    	    break;
    	case option_corrthresh:
    	    {
    		char *endptr; double tmp = std::strtod(value, &endptr);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid floating point value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 0.0) {
    		    throw option_error("floating point value out of range, 'corr-threshold' min is 0.0");
    		}

    		if (tmp > 1.0) {
    		    throw option_error("floating point value out of range, 'corr-threshold' max is 1.0");
    		}

    		options_.corrthresh = tmp;
    	    }
    	    break;
    	case option_format:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		options_.format = tmp;
    	    }
    	    break;
    	case option_gagenerations:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 10) {
    		    throw option_error("integer value out of range, 'ga-generations' min is 10");
    		}

    		options_.gagenerations = tmp;
    	    }
    	    break;
    	case option_gagenes:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 0) {
    		    throw option_error("integer value out of range, 'ga-genes' min is 0");
    		}

    		options_.gagenes = tmp;
    	    }
    	    break;
    	case option_gapop:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 4) {
    		    throw option_error("integer value out of range, 'ga-population' min is 4");
    		}

    		options_.gapop = tmp;
    	    }
    	    break;
    	case option_logdata:
    	    {
    		logdata_enum evalue;

    		if (strcmp(value, "10") == 0) {
    		    evalue = logdata_10;
    		} else if (strcmp(value, "2") == 0) {
    		    evalue = logdata_2;
    		} else if (strcmp(value, "e") == 0) {
    		    evalue = logdata_e;
    		} else if (strcmp(value, "nop") == 0) {
    		    evalue = logdata_nop;
    		} else {
    		    std::string error("'"); error += value; error += "' is an invalid value for the 'logdata' option";
    		    throw option_error(error);
    		}

    		options_.logdata = evalue;
    	    }
    	    break;
    	case option_method:
    	    {
    		method_enum evalue;

    		if (strcmp(value, "correlation") == 0) {
    		    evalue = method_corr;
    		} else if (strcmp(value, "fa") == 0) {
    		    evalue = method_fa;
    		} else if (strcmp(value, "ga-dfa") == 0) {
    		    evalue = method_gadfa;
    		} else if (strcmp(value, "ga-dfa2") == 0) {
    		    evalue = method_gadfa2;
    		} else if (strcmp(value, "mda") == 0) {
    		    evalue = method_mda;
    		} else if (strcmp(value, "nmf") == 0) {
    		    evalue = method_nmf;
    		} else if (strcmp(value, "nop") == 0) {
    		    evalue = method_nop;
    		} else if (strcmp(value, "partial_correlation") == 0) {
    		    evalue = method_partcorr;
    		} else if (strcmp(value, "pca") == 0) {
    		    evalue = method_pca;
    		} else if (strcmp(value, "transpose") == 0) {
    		    evalue = method_transpose;
    		} else {
    		    std::string error("'"); error += value; error += "' is an invalid value for the 'method' option";
    		    throw option_error(error);
    		}

    		options_.method = evalue;
    	    }
    	    break;
    	case option_output:
    	    {
    		options_.output = value;
    	    }
    	    break;
    	case option_proj2dplots:
    	    break;
    	case option_projdim:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 0) {
    		    throw option_error("integer value out of range, 'proj-dimension' min is 0");
    		}

    		options_.projdim = tmp;
    	    }
    	    break;
    	case option_projvar:
    	    {
    		char *endptr; double tmp = std::strtod(value, &endptr);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid floating point value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 0.0) {
    		    throw option_error("floating point value out of range, 'proj-variance' min is 0.0");
    		}

    		if (tmp > 1.0) {
    		    throw option_error("floating point value out of range, 'proj-variance' max is 1.0");
    		}

    		options_.projvar = tmp;
    	    }
    	    break;
    	case option_pval:
    	    {
    		char *endptr; double tmp = std::strtod(value, &endptr);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid floating point value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		if (tmp < 0.0) {
    		    throw option_error("floating point value out of range, 'pval' min is 0.0");
    		}

    		if (tmp > 1.0) {
    		    throw option_error("floating point value out of range, 'pval' max is 1.0");
    		}

    		options_.pval = tmp;
    	    }
    	    break;
    	case option_samplescenter:
    	    break;
    	case option_samplesz:
    	    break;
    	case option_sampletot:
    	    {
    		char *endptr; double tmp = std::strtod(value, &endptr);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid floating point value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		options_.sampletot = tmp;
    	    }
    	    break;
    	case option_spearman:
    	    break;
    	case option_splot:
    	    break;
    	case option_splotlog:
    	    break;
    	case option_splotnormal:
    	    break;
    	case option_splotpng:
    	    break;
    	case option_splotscale:
    	    break;
    	case option_varscenter:
    	    break;
    	case option_varsz:
    	    break;
    	case option_verbose:
    	    {
    		char *endptr; int tmp = std::strtol(value, &endptr, 0);
    		while (*endptr != 0 && std::isspace(*endptr)) ++endptr;

    		if (*endptr != 0) {
    		    std::string error("invalid integer value '"); error += value; error += "'";
    		    throw option_error(error);
    		}

    		options_.verbose = tmp;
    	    }
    	    break;
    	case option_version:
    	    break;
    }
}
//#########################################################################
const char* clo::option_error::get_help_comment (void) const {
    return const_help_comment;
}
//#########################################################################
namespace {
    const char* expand_long_name (const std::string &name) {
	std::string::size_type name_size = name.size();
	std::vector<const char*> matches;

        if (name_size <= 12 && name.compare(0, name_size, "biplot-alpha", name_size) == 0)
        	matches.push_back("biplot-alpha");

        if (name_size <= 10 && name.compare(0, name_size, "biplot-dim", name_size) == 0)
        	matches.push_back("biplot-dim");

        if (name_size <= 11 && name.compare(0, name_size, "biplot-vars", name_size) == 0)
        	matches.push_back("biplot-vars");

        if (name_size <= 23 && name.compare(0, name_size, "comparative-correlation", name_size) == 0)
        	matches.push_back("comparative-correlation");

        if (name_size <= 10 && name.compare(0, name_size, "corr-graph", name_size) == 0)
        	matches.push_back("corr-graph");

        if (name_size <= 14 && name.compare(0, name_size, "corr-threshold", name_size) == 0)
        	matches.push_back("corr-threshold");

        if (name_size <= 6 && name.compare(0, name_size, "format", name_size) == 0)
        	matches.push_back("format");

        if (name_size <= 14 && name.compare(0, name_size, "ga-generations", name_size) == 0)
        	matches.push_back("ga-generations");

        if (name_size <= 8 && name.compare(0, name_size, "ga-genes", name_size) == 0)
        	matches.push_back("ga-genes");

        if (name_size <= 13 && name.compare(0, name_size, "ga-population", name_size) == 0)
        	matches.push_back("ga-population");

        if (name_size <= 9 && name.compare(0, name_size, "log-plots", name_size) == 0)
        	matches.push_back("log-plots");

        if (name_size <= 7 && name.compare(0, name_size, "logdata", name_size) == 0)
        	matches.push_back("logdata");

        if (name_size <= 6 && name.compare(0, name_size, "method", name_size) == 0)
        	matches.push_back("method");

        if (name_size <= 15 && name.compare(0, name_size, "normalize-plots", name_size) == 0)
        	matches.push_back("normalize-plots");

        if (name_size <= 6 && name.compare(0, name_size, "output", name_size) == 0)
        	matches.push_back("output");

        if (name_size <= 8 && name.compare(0, name_size, "plot-png", name_size) == 0)
        	matches.push_back("plot-png");

        if (name_size <= 12 && name.compare(0, name_size, "proj-2dplots", name_size) == 0)
        	matches.push_back("proj-2dplots");

        if (name_size <= 14 && name.compare(0, name_size, "proj-dimension", name_size) == 0)
        	matches.push_back("proj-dimension");

        if (name_size <= 13 && name.compare(0, name_size, "proj-variance", name_size) == 0)
        	matches.push_back("proj-variance");

        if (name_size <= 4 && name.compare(0, name_size, "pval", name_size) == 0)
        	matches.push_back("pval");

        if (name_size <= 14 && name.compare(0, name_size, "samples-center", name_size) == 0)
        	matches.push_back("samples-center");

        if (name_size <= 13 && name.compare(0, name_size, "samples-total", name_size) == 0)
        	matches.push_back("samples-total");

        if (name_size <= 9 && name.compare(0, name_size, "samples-z", name_size) == 0)
        	matches.push_back("samples-z");

        if (name_size <= 11 && name.compare(0, name_size, "scale-plots", name_size) == 0)
        	matches.push_back("scale-plots");

        if (name_size <= 12 && name.compare(0, name_size, "scatterplots", name_size) == 0)
        	matches.push_back("scatterplots");

        if (name_size <= 8 && name.compare(0, name_size, "spearman", name_size) == 0)
        	matches.push_back("spearman");

        if (name_size <= 11 && name.compare(0, name_size, "vars-center", name_size) == 0)
        	matches.push_back("vars-center");

        if (name_size <= 6 && name.compare(0, name_size, "vars-z", name_size) == 0)
        	matches.push_back("vars-z");

        if (name_size <= 7 && name.compare(0, name_size, "verbose", name_size) == 0)
        	matches.push_back("verbose");

        if (name_size <= 7 && name.compare(0, name_size, "version", name_size) == 0)
        	matches.push_back("version");

        if (name_size <= 4 && name.compare(0, name_size, "help", name_size) == 0)
        	matches.push_back("help");


	if (matches.empty()) {
	    std::string error("unknown option '"); error += name; error += "'";
	    throw clo::option_error(error);
	}

	if (matches.size() == 1) {
	    return matches[0];
	}

	std::string error("the option name '"); error += name; error += "' is ambiguous";
	throw clo::option_error(error);
    }
} // end anonymous namespace
