/*
 * This file was automaticly generated by clo++ version 0.6.4 (REL-0_6_4)
 * http://pmade.org/pjones/software/clo++/
 *
 * Template enhancements by Stefan Hoops mailto:shoops@vt.edu
 */

/** 
 * This is the main header file (clo.h).
 * You can control the name of this header file using the
 * cxx_header_file variable.
 */

// you can control the include guard
// name with the cxx_header_def variable
#ifndef clo_h
#define clo_h


// standard includes
#include <stdexcept>
#include <string>
#include <vector>

/// the namespace can be controlled using the cxx_namespace variable
namespace clo
  {
  /**
   * a list of autothrow ids for the autoexcept exception class
   * so that you know which option caused the exception.
   */
  enum autothrow
  { 
    autothrow_help
  };

    enum logdata_enum 
{
	logdata_10,
	logdata_2,
	logdata_e,
	logdata_nop
    };

    enum method_enum 
{
	method_corr,
	method_fa,
	method_gadfa,
	method_gadfa2,
	method_mda,
	method_nmf,
	method_nop,
	method_partcorr,
	method_pca,
	method_transpose
    };

/**
 * the following struct is used to hold the values of
 * the options. It has a constructor that sets all the option 
 * values to their default value.
 */
struct options
{
  options(void) :
	    biplot(0),
	    biplotalpha(0.5),
	    biplotvars("++"),
	    compcorr(0.0),
	    corrgraph(false),
	    corrthresh(0.0),
	    format(1),
	    gagenerations(100),
	    gagenes(0),
	    gapop(10),
	    logdata(logdata_nop),
	    method(method_nop),
	    output("ometer-results"),
	    proj2dplots(false),
	    projdim(0),
	    projvar(0.0),
	    pval(1.0),
	    samplescenter(false),
	    samplesz(false),
	    sampletot(0.0),
	    spearman(false),
	    splot(false),
	    splotlog(false),
	    splotnormal(false),
	    splotpng(false),
	    splotscale(false),
	    varscenter(false),
	    varsz(false),
	    verbose(0),
	    version(false)
	{}
      	        	int     biplot;
      	        	double     biplotalpha;
      	        	std::string     biplotvars;
      	        	double     compcorr;
      	        	bool     corrgraph;
      	        	double     corrthresh;
      	        	int     format;
      	        	int     gagenerations;
      	        	int     gagenes;
      	        	int     gapop;
      	        	logdata_enum     logdata;
      	        	method_enum     method;
      	        	std::string     output;
      	        	bool     proj2dplots;
      	        	int     projdim;
      	        	double     projvar;
      	        	double     pval;
      	        	bool     samplescenter;
      	        	bool     samplesz;
      	        	double     sampletot;
      	        	bool     spearman;
      	        	bool     splot;
      	        	bool     splotlog;
      	        	bool     splotnormal;
      	        	bool     splotpng;
      	        	bool     splotscale;
      	        	bool     varscenter;
      	        	bool     varsz;
      	        	int     verbose;
      	        	bool     version;
}; // end options struct

/**
 * the following struct is used to record the location
 * on the command line where the option was found.
 */
struct option_locations
 {
typedef int size_type;
size_type biplot;
size_type biplotalpha;
size_type biplotvars;
size_type compcorr;
size_type corrgraph;
size_type corrthresh;
size_type format;
size_type gagenerations;
size_type gagenes;
size_type gapop;
size_type logdata;
size_type method;
size_type output;
size_type proj2dplots;
size_type projdim;
size_type projvar;
size_type pval;
size_type samplescenter;
size_type samplesz;
size_type sampletot;
size_type spearman;
size_type splot;
size_type splotlog;
size_type splotnormal;
size_type splotpng;
size_type splotscale;
size_type varscenter;
size_type varsz;
size_type verbose;
size_type version;
}; // end option location struct

    /**
     * if there are any errors while parsing the command
     * line, the following class will be thrown.
     */
    class option_error : public std::runtime_error 
{
    public:
	option_error (const std::string &what_arg)
	    : runtime_error(what_arg) { }
	
	const char* get_help_comment (void) const;
    };

    /**
     * if any option that is a autothrow option is present
     * on the command line, this exception class will be
     * thrown when that option is parsed.
     */
    class autoexcept : public option_error 
{
    public:
	// constructor
	autoexcept (autothrow id, const std::string &message)
	    : option_error(message), autothrow_(id) { }
    
	/**
	 * get the autothrow enum member for the autothrow
	 * option that caused the exception.
	 */
	autothrow get_autothrow_id (void) const
	{ return autothrow_; }
    private:
	autothrow autothrow_;
    };

    /**
     * the parser class is the main command
     * line parsing class. You can control the name of it
     * using the cxx_class variable.
     */
    class parser 
{
    public:
	/// default constructor
	parser (void);
    
	/// parse the command line
	void parse(int argc, char *argv[], bool call_finalize=true);

	/// parse a file
	void parse(const char * fileName);

	/// finalize all parsing (eg. check for mandatory options)
	void finalize (void);

	/// get a list of nonoptions from the command line
	const std::vector<std::string>& get_non_options (void) const
	{ return non_options_; }

	/// get the main options
	const options& get_options (void) const
	{ return options_; }

	/// get the main option locations
	const option_locations& get_locations (void) const
	{ return locations_; }
    private:
	options options_;
	option_locations locations_;

	enum options_enum 
{
	    option_version,
		option_output,
		option_format,
		option_verbose,
		option_sampletot,
		option_samplesz,
		option_varsz,
		option_samplescenter,
		option_varscenter,
		option_logdata,
		option_method,
		option_spearman,
		option_corrthresh,
		option_pval,
		option_compcorr,
		option_corrgraph,
		option_splot,
		option_splotscale,
		option_splotnormal,
		option_splotlog,
		option_splotpng,
		option_gapop,
		option_gagenes,
		option_gagenerations,
		option_projvar,
		option_projdim,
		option_proj2dplots,
		option_biplot,
		option_biplotalpha,
		option_biplotvars
	} openum_;

	enum parser_state { state_option, state_value, state_consume } state_;
	std::vector<std::string> non_options_;

	enum opsource 
{
source_cl,
source_cf
 };
	void parse_element      (const char *element, int position, opsource source);
	void parse_short_option (char option, int position, opsource source);
	void parse_long_option  (const char *option, int position, opsource source);
	void parse_value        (const char *value);
    }; // end clo::parser class
} // end clo namespace
#endif // clo_h
