/***************************************************************************
 *   ometer is software for processing biochemical profiling data          *
 *                                                                         *
 *   Copyright (C) 2004 by Pedro Mendes, Virginia Bioinformatics Institute *
 *   mendes@vt.edu                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 ***************************************************************************/

/***************************************************************************
 * correlation.cpp header for correlation analysis                         *
 ***************************************************************************/ 

int correlationAnalysis( map <string, datum *> &entity, int totstates, double ***corr, int ***ncorr, int telem, bool spearman, double threshold, double pval, bool dograph, int splotscale, bool png, const char *ofname, FILE *htmlfile);
int comparativeCorrelation( map <string, datum *> &entity, int totstates, double ***corr, int ***ncorr, int telem, double pval, bool splot, int splotscale, bool png, const char *ofname, FILE *htmlfile);
int partialCorrelation( map <string, datum *> &entity, int states, double ***corr, int ***ncorr, int etot, double threshold, double pval, bool corrgraph, const char *ofname, FILE *htmlfile);
void correlationPearson(  map<string, datum *>::iterator dat_i, map<string, datum *>::iterator dat_j, int state, double *r, int *n );
void correlationSpearman(  map<string, datum *>::iterator dat_i, map<string, datum *>::iterator dat_j, int state, double *r, int *n );
double correlationThreshold( double p, int n, int d);
double correlationP( double r, int n, int d);
void correlationDot( map <string, datum *> &entity, int totstates, double ***corr, int ***ncorr, int telem, double threshold, double pval, bool partial, const char *ofname);
void scatterSingleState( const char *ofname, map<string, datum *>::iterator dat_i, map<string, datum *>::iterator dat_j, int s, int n, double r, double npval, int splotscale, char *fname );
void scatterTwoStates( const char *ofname, map<string, datum *>::iterator dat_i, map<string, datum *>::iterator dat_j, int s1, int s2, double r1, double r2, int splotscale, char *sfname );
